#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_i_i_d_p(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__i_i_d_p)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__i_i_d_p);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int iket;
    int ibra;

    // partition workspace
    double * const INT__i_s_d_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__i_s_f_s = work + (SIMINT_NSHELL_SIMD * 168);
    double * const INT__k_s_d_s = work + (SIMINT_NSHELL_SIMD * 448);
    double * const INT__k_s_f_s = work + (SIMINT_NSHELL_SIMD * 664);
    double * const INT__l_s_d_s = work + (SIMINT_NSHELL_SIMD * 1024);
    double * const INT__l_s_f_s = work + (SIMINT_NSHELL_SIMD * 1294);
    double * const INT__m_s_d_s = work + (SIMINT_NSHELL_SIMD * 1744);
    double * const INT__m_s_f_s = work + (SIMINT_NSHELL_SIMD * 2074);
    double * const INT__n_s_d_s = work + (SIMINT_NSHELL_SIMD * 2624);
    double * const INT__n_s_f_s = work + (SIMINT_NSHELL_SIMD * 3020);
    double * const INT__o_s_d_s = work + (SIMINT_NSHELL_SIMD * 3680);
    double * const INT__o_s_f_s = work + (SIMINT_NSHELL_SIMD * 4148);
    double * const INT__q_s_d_s = work + (SIMINT_NSHELL_SIMD * 4928);
    double * const INT__q_s_f_s = work + (SIMINT_NSHELL_SIMD * 5474);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*6384);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_s_s = primwork + 16;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_s_s = primwork + 61;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_s_s = primwork + 145;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_s_s = primwork + 275;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_p_s = primwork + 455;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_s_s = primwork + 590;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_p_s = primwork + 821;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_d_s = primwork + 1010;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_s_s = primwork + 1262;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_p_s = primwork + 1542;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_d_s = primwork + 1794;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_f_s = primwork + 2130;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_s_s = primwork + 2410;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_p_s = primwork + 2734;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_d_s = primwork + 3058;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_f_s = primwork + 3490;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_s_s = primwork + 3850;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_p_s = primwork + 4210;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_d_s = primwork + 4615;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_f_s = primwork + 5155;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_s_s = primwork + 5605;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_p_s = primwork + 5990;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_d_s = primwork + 6485;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_f_s = primwork + 7145;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_s_s = primwork + 7695;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_p_s = primwork + 8091;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_d_s = primwork + 8685;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_f_s = primwork + 9477;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_s_s = primwork + 10137;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_p_s = primwork + 10527;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_d_s = primwork + 11229;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_f_s = primwork + 12165;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_s_s = primwork + 12945;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_p_s = primwork + 13309;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_d_s = primwork + 14128;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_f_s = primwork + 15220;
    double * const hrrwork = (double *)(primwork + 16130);
    double * const HRR_INT__i_p_d_s = hrrwork + 0;
    double * const HRR_INT__i_p_f_s = hrrwork + 504;
    double * const HRR_INT__i_d_d_s = hrrwork + 1344;
    double * const HRR_INT__i_d_f_s = hrrwork + 2352;
    double * const HRR_INT__i_f_d_s = hrrwork + 4032;
    double * const HRR_INT__i_f_f_s = hrrwork + 5712;
    double * const HRR_INT__i_g_d_s = hrrwork + 8512;
    double * const HRR_INT__i_g_f_s = hrrwork + 11032;
    double * const HRR_INT__i_h_d_s = hrrwork + 15232;
    double * const HRR_INT__i_h_f_s = hrrwork + 18760;
    double * const HRR_INT__i_i_d_s = hrrwork + 24640;
    double * const HRR_INT__i_i_f_s = hrrwork + 29344;
    double * const HRR_INT__k_p_d_s = hrrwork + 37184;
    double * const HRR_INT__k_p_f_s = hrrwork + 37832;
    double * const HRR_INT__k_d_d_s = hrrwork + 38912;
    double * const HRR_INT__k_d_f_s = hrrwork + 40208;
    double * const HRR_INT__k_f_d_s = hrrwork + 42368;
    double * const HRR_INT__k_f_f_s = hrrwork + 44528;
    double * const HRR_INT__k_g_d_s = hrrwork + 48128;
    double * const HRR_INT__k_g_f_s = hrrwork + 51368;
    double * const HRR_INT__k_h_d_s = hrrwork + 56768;
    double * const HRR_INT__k_h_f_s = hrrwork + 61304;
    double * const HRR_INT__l_p_d_s = hrrwork + 68864;
    double * const HRR_INT__l_p_f_s = hrrwork + 69674;
    double * const HRR_INT__l_d_d_s = hrrwork + 71024;
    double * const HRR_INT__l_d_f_s = hrrwork + 72644;
    double * const HRR_INT__l_f_d_s = hrrwork + 75344;
    double * const HRR_INT__l_f_f_s = hrrwork + 78044;
    double * const HRR_INT__l_g_d_s = hrrwork + 82544;
    double * const HRR_INT__l_g_f_s = hrrwork + 86594;
    double * const HRR_INT__m_p_d_s = hrrwork + 93344;
    double * const HRR_INT__m_p_f_s = hrrwork + 94334;
    double * const HRR_INT__m_d_d_s = hrrwork + 95984;
    double * const HRR_INT__m_d_f_s = hrrwork + 97964;
    double * const HRR_INT__m_f_d_s = hrrwork + 101264;
    double * const HRR_INT__m_f_f_s = hrrwork + 104564;
    double * const HRR_INT__n_p_d_s = hrrwork + 110064;
    double * const HRR_INT__n_p_f_s = hrrwork + 111252;
    double * const HRR_INT__n_d_d_s = hrrwork + 113232;
    double * const HRR_INT__n_d_f_s = hrrwork + 115608;
    double * const HRR_INT__o_p_d_s = hrrwork + 119568;
    double * const HRR_INT__o_p_f_s = hrrwork + 120972;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_12 = SIMINT_DBLSET1(12);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 6384 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__i_s_d_s = INT__i_s_d_s + abcd * 168;
                double * restrict PRIM_PTR_INT__i_s_f_s = INT__i_s_f_s + abcd * 280;
                double * restrict PRIM_PTR_INT__k_s_d_s = INT__k_s_d_s + abcd * 216;
                double * restrict PRIM_PTR_INT__k_s_f_s = INT__k_s_f_s + abcd * 360;
                double * restrict PRIM_PTR_INT__l_s_d_s = INT__l_s_d_s + abcd * 270;
                double * restrict PRIM_PTR_INT__l_s_f_s = INT__l_s_f_s + abcd * 450;
                double * restrict PRIM_PTR_INT__m_s_d_s = INT__m_s_d_s + abcd * 330;
                double * restrict PRIM_PTR_INT__m_s_f_s = INT__m_s_f_s + abcd * 550;
                double * restrict PRIM_PTR_INT__n_s_d_s = INT__n_s_d_s + abcd * 396;
                double * restrict PRIM_PTR_INT__n_s_f_s = INT__n_s_f_s + abcd * 660;
                double * restrict PRIM_PTR_INT__o_s_d_s = INT__o_s_d_s + abcd * 468;
                double * restrict PRIM_PTR_INT__o_s_f_s = INT__o_s_f_s + abcd * 780;
                double * restrict PRIM_PTR_INT__q_s_d_s = INT__q_s_d_s + abcd * 546;
                double * restrict PRIM_PTR_INT__q_s_f_s = INT__q_s_f_s + abcd * 910;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };

                const SIMINT_DBLTYPE P_PA[3] = { SIMINT_DBLSET1(P.PA_x[i]), SIMINT_DBLSET1(P.PA_y[i]), SIMINT_DBLSET1(P.PA_z[i]) };

                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__i_s_d_s += 168;
                            PRIM_PTR_INT__i_s_f_s += 280;
                            PRIM_PTR_INT__k_s_d_s += 216;
                            PRIM_PTR_INT__k_s_f_s += 360;
                            PRIM_PTR_INT__l_s_d_s += 270;
                            PRIM_PTR_INT__l_s_f_s += 450;
                            PRIM_PTR_INT__m_s_d_s += 330;
                            PRIM_PTR_INT__m_s_f_s += 550;
                            PRIM_PTR_INT__n_s_d_s += 396;
                            PRIM_PTR_INT__n_s_f_s += 660;
                            PRIM_PTR_INT__o_s_d_s += 468;
                            PRIM_PTR_INT__o_s_f_s += 780;
                            PRIM_PTR_INT__q_s_d_s += 546;
                            PRIM_PTR_INT__q_s_f_s += 910;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__i_s_d_s += lastoffset*168;
                            PRIM_PTR_INT__i_s_f_s += lastoffset*280;
                            PRIM_PTR_INT__k_s_d_s += lastoffset*216;
                            PRIM_PTR_INT__k_s_f_s += lastoffset*360;
                            PRIM_PTR_INT__l_s_d_s += lastoffset*270;
                            PRIM_PTR_INT__l_s_f_s += lastoffset*450;
                            PRIM_PTR_INT__m_s_d_s += lastoffset*330;
                            PRIM_PTR_INT__m_s_f_s += lastoffset*550;
                            PRIM_PTR_INT__n_s_d_s += lastoffset*396;
                            PRIM_PTR_INT__n_s_f_s += lastoffset*660;
                            PRIM_PTR_INT__o_s_d_s += lastoffset*468;
                            PRIM_PTR_INT__o_s_f_s += lastoffset*780;
                            PRIM_PTR_INT__q_s_d_s += lastoffset*546;
                            PRIM_PTR_INT__q_s_f_s += lastoffset*910;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    // NOTE: Minus sign!
                    const SIMINT_DBLTYPE a_over_p = SIMINT_MUL(SIMINT_NEG(alpha), one_over_p);
                    SIMINT_DBLTYPE aop_PQ[3];
                    aop_PQ[0] = SIMINT_MUL(a_over_p, PQ[0]);
                    aop_PQ[1] = SIMINT_MUL(a_over_p, PQ[1]);
                    aop_PQ[2] = SIMINT_MUL(a_over_p, PQ[2]);

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 15
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 15);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 15; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2p = one_over_2p;
                    const SIMINT_DBLTYPE vrr_const_2_over_2p = SIMINT_MUL(const_2, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_3_over_2p = SIMINT_MUL(const_3, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_4_over_2p = SIMINT_MUL(const_4, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_5_over_2p = SIMINT_MUL(const_5, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_6_over_2p = SIMINT_MUL(const_6, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_7_over_2p = SIMINT_MUL(const_7, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_8_over_2p = SIMINT_MUL(const_8, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_9_over_2p = SIMINT_MUL(const_9, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_10_over_2p = SIMINT_MUL(const_10, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_11_over_2p = SIMINT_MUL(const_11, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_2_over_2q = SIMINT_MUL(const_2, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_1_over_2pq = one_over_2pq;
                    const SIMINT_DBLTYPE vrr_const_2_over_2pq = SIMINT_MUL(const_2, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_3_over_2pq = SIMINT_MUL(const_3, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_4_over_2pq = SIMINT_MUL(const_4, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_5_over_2pq = SIMINT_MUL(const_5, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_6_over_2pq = SIMINT_MUL(const_6, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_7_over_2pq = SIMINT_MUL(const_7, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_8_over_2pq = SIMINT_MUL(const_8, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_9_over_2pq = SIMINT_MUL(const_9, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_10_over_2pq = SIMINT_MUL(const_10, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_11_over_2pq = SIMINT_MUL(const_11, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_12_over_2pq = SIMINT_MUL(const_12, one_over_2pq);



                    // Forming PRIM_INT__p_s_s_s[15 * 3];
                    for(n = 0; n < 15; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]);

                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 1]);

                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__d_s_s_s[14 * 6];
                    for(n = 0; n < 14; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 0]);

                        PRIM_INT__d_s_s_s[n * 6 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 1]);

                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 1]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 3]);

                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__p_s_s_s[n * 3 + 2]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__f_s_s_s[13 * 10];
                    for(n = 0; n < 13; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]), PRIM_INT__f_s_s_s[n * 10 + 0]);

                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 1]);

                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 2]);

                        PRIM_INT__f_s_s_s[n * 10 + 3] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 3] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 3]);

                        PRIM_INT__f_s_s_s[n * 10 + 4] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 1]);
                        PRIM_INT__f_s_s_s[n * 10 + 4] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 1], PRIM_INT__f_s_s_s[n * 10 + 4]);

                        PRIM_INT__f_s_s_s[n * 10 + 5] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 5] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 5]);

                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__p_s_s_s[n * 3 + 1]), PRIM_INT__f_s_s_s[n * 10 + 6]);

                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 7]);

                        PRIM_INT__f_s_s_s[n * 10 + 8] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 8] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 8]);

                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__p_s_s_s[n * 3 + 2]), PRIM_INT__f_s_s_s[n * 10 + 9]);

                    }


                    VRR_I_g_s_s_s(
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            PRIM_INT__d_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            12);


                    VRR_I_h_s_s_s(
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            11);


                    ostei_general_vrr1_I(6, 10,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__h_s_s_s, PRIM_INT__g_s_s_s, PRIM_INT__i_s_s_s);


                    ostei_general_vrr_K(6, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_s_s, NULL, NULL, PRIM_INT__h_s_s_s, NULL, PRIM_INT__i_s_p_s);


                    ostei_general_vrr_K(5, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__h_s_s_s, NULL, NULL, PRIM_INT__g_s_s_s, NULL, PRIM_INT__h_s_p_s);


                    ostei_general_vrr_K(6, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_p_s, PRIM_INT__i_s_s_s, NULL, PRIM_INT__h_s_p_s, NULL, PRIM_INT__i_s_d_s);


                    VRR_K_g_s_p_s(
                            PRIM_INT__g_s_p_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            3);


                    ostei_general_vrr_K(5, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__h_s_p_s, PRIM_INT__h_s_s_s, NULL, PRIM_INT__g_s_p_s, NULL, PRIM_INT__h_s_d_s);


                    ostei_general_vrr_K(6, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_d_s, PRIM_INT__i_s_p_s, NULL, PRIM_INT__h_s_d_s, NULL, PRIM_INT__i_s_f_s);


                    ostei_general_vrr1_I(7, 9,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__i_s_s_s, PRIM_INT__h_s_s_s, PRIM_INT__k_s_s_s);


                    ostei_general_vrr_K(7, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_s_s, NULL, NULL, PRIM_INT__i_s_s_s, NULL, PRIM_INT__k_s_p_s);


                    ostei_general_vrr_K(7, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_p_s, PRIM_INT__k_s_s_s, NULL, PRIM_INT__i_s_p_s, NULL, PRIM_INT__k_s_d_s);


                    ostei_general_vrr_K(7, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_d_s, PRIM_INT__k_s_p_s, NULL, PRIM_INT__i_s_d_s, NULL, PRIM_INT__k_s_f_s);


                    ostei_general_vrr1_I(8, 8,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__k_s_s_s, PRIM_INT__i_s_s_s, PRIM_INT__l_s_s_s);


                    ostei_general_vrr_K(8, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_s_s, NULL, NULL, PRIM_INT__k_s_s_s, NULL, PRIM_INT__l_s_p_s);


                    ostei_general_vrr_K(8, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_p_s, PRIM_INT__l_s_s_s, NULL, PRIM_INT__k_s_p_s, NULL, PRIM_INT__l_s_d_s);


                    ostei_general_vrr_K(8, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_d_s, PRIM_INT__l_s_p_s, NULL, PRIM_INT__k_s_d_s, NULL, PRIM_INT__l_s_f_s);


                    ostei_general_vrr1_I(9, 7,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__l_s_s_s, PRIM_INT__k_s_s_s, PRIM_INT__m_s_s_s);


                    ostei_general_vrr_K(9, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_s_s, NULL, NULL, PRIM_INT__l_s_s_s, NULL, PRIM_INT__m_s_p_s);


                    ostei_general_vrr_K(9, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_p_s, PRIM_INT__m_s_s_s, NULL, PRIM_INT__l_s_p_s, NULL, PRIM_INT__m_s_d_s);


                    ostei_general_vrr_K(9, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_d_s, PRIM_INT__m_s_p_s, NULL, PRIM_INT__l_s_d_s, NULL, PRIM_INT__m_s_f_s);


                    ostei_general_vrr1_I(10, 6,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__m_s_s_s, PRIM_INT__l_s_s_s, PRIM_INT__n_s_s_s);


                    ostei_general_vrr_K(10, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_s_s, NULL, NULL, PRIM_INT__m_s_s_s, NULL, PRIM_INT__n_s_p_s);


                    ostei_general_vrr_K(10, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_p_s, PRIM_INT__n_s_s_s, NULL, PRIM_INT__m_s_p_s, NULL, PRIM_INT__n_s_d_s);


                    ostei_general_vrr_K(10, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_d_s, PRIM_INT__n_s_p_s, NULL, PRIM_INT__m_s_d_s, NULL, PRIM_INT__n_s_f_s);


                    ostei_general_vrr1_I(11, 5,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__n_s_s_s, PRIM_INT__m_s_s_s, PRIM_INT__o_s_s_s);


                    ostei_general_vrr_K(11, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_s_s, NULL, NULL, PRIM_INT__n_s_s_s, NULL, PRIM_INT__o_s_p_s);


                    ostei_general_vrr_K(11, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_p_s, PRIM_INT__o_s_s_s, NULL, PRIM_INT__n_s_p_s, NULL, PRIM_INT__o_s_d_s);


                    ostei_general_vrr_K(11, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_d_s, PRIM_INT__o_s_p_s, NULL, PRIM_INT__n_s_d_s, NULL, PRIM_INT__o_s_f_s);


                    ostei_general_vrr1_I(12, 4,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__o_s_s_s, PRIM_INT__n_s_s_s, PRIM_INT__q_s_s_s);


                    ostei_general_vrr_K(12, 0, 1, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_s_s, NULL, NULL, PRIM_INT__o_s_s_s, NULL, PRIM_INT__q_s_p_s);


                    ostei_general_vrr_K(12, 0, 2, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_p_s, PRIM_INT__q_s_s_s, NULL, PRIM_INT__o_s_p_s, NULL, PRIM_INT__q_s_d_s);


                    ostei_general_vrr_K(12, 0, 3, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_d_s, PRIM_INT__q_s_p_s, NULL, PRIM_INT__o_s_d_s, NULL, PRIM_INT__q_s_f_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(168, PRIM_INT__i_s_d_s, PRIM_PTR_INT__i_s_d_s);
                        contract_all(280, PRIM_INT__i_s_f_s, PRIM_PTR_INT__i_s_f_s);
                        contract_all(216, PRIM_INT__k_s_d_s, PRIM_PTR_INT__k_s_d_s);
                        contract_all(360, PRIM_INT__k_s_f_s, PRIM_PTR_INT__k_s_f_s);
                        contract_all(270, PRIM_INT__l_s_d_s, PRIM_PTR_INT__l_s_d_s);
                        contract_all(450, PRIM_INT__l_s_f_s, PRIM_PTR_INT__l_s_f_s);
                        contract_all(330, PRIM_INT__m_s_d_s, PRIM_PTR_INT__m_s_d_s);
                        contract_all(550, PRIM_INT__m_s_f_s, PRIM_PTR_INT__m_s_f_s);
                        contract_all(396, PRIM_INT__n_s_d_s, PRIM_PTR_INT__n_s_d_s);
                        contract_all(660, PRIM_INT__n_s_f_s, PRIM_PTR_INT__n_s_f_s);
                        contract_all(468, PRIM_INT__o_s_d_s, PRIM_PTR_INT__o_s_d_s);
                        contract_all(780, PRIM_INT__o_s_f_s, PRIM_PTR_INT__o_s_f_s);
                        contract_all(546, PRIM_INT__q_s_d_s, PRIM_PTR_INT__q_s_d_s);
                        contract_all(910, PRIM_INT__q_s_f_s, PRIM_PTR_INT__q_s_f_s);
                    }
                    else
                    {
                        contract(168, shelloffsets, PRIM_INT__i_s_d_s, PRIM_PTR_INT__i_s_d_s);
                        contract(280, shelloffsets, PRIM_INT__i_s_f_s, PRIM_PTR_INT__i_s_f_s);
                        contract(216, shelloffsets, PRIM_INT__k_s_d_s, PRIM_PTR_INT__k_s_d_s);
                        contract(360, shelloffsets, PRIM_INT__k_s_f_s, PRIM_PTR_INT__k_s_f_s);
                        contract(270, shelloffsets, PRIM_INT__l_s_d_s, PRIM_PTR_INT__l_s_d_s);
                        contract(450, shelloffsets, PRIM_INT__l_s_f_s, PRIM_PTR_INT__l_s_f_s);
                        contract(330, shelloffsets, PRIM_INT__m_s_d_s, PRIM_PTR_INT__m_s_d_s);
                        contract(550, shelloffsets, PRIM_INT__m_s_f_s, PRIM_PTR_INT__m_s_f_s);
                        contract(396, shelloffsets, PRIM_INT__n_s_d_s, PRIM_PTR_INT__n_s_d_s);
                        contract(660, shelloffsets, PRIM_INT__n_s_f_s, PRIM_PTR_INT__n_s_f_s);
                        contract(468, shelloffsets, PRIM_INT__o_s_d_s, PRIM_PTR_INT__o_s_d_s);
                        contract(780, shelloffsets, PRIM_INT__o_s_f_s, PRIM_PTR_INT__o_s_f_s);
                        contract(546, shelloffsets, PRIM_INT__q_s_d_s, PRIM_PTR_INT__q_s_d_s);
                        contract(910, shelloffsets, PRIM_INT__q_s_f_s, PRIM_PTR_INT__q_s_f_s);
                        PRIM_PTR_INT__i_s_d_s += lastoffset*168;
                        PRIM_PTR_INT__i_s_f_s += lastoffset*280;
                        PRIM_PTR_INT__k_s_d_s += lastoffset*216;
                        PRIM_PTR_INT__k_s_f_s += lastoffset*360;
                        PRIM_PTR_INT__l_s_d_s += lastoffset*270;
                        PRIM_PTR_INT__l_s_f_s += lastoffset*450;
                        PRIM_PTR_INT__m_s_d_s += lastoffset*330;
                        PRIM_PTR_INT__m_s_f_s += lastoffset*550;
                        PRIM_PTR_INT__n_s_d_s += lastoffset*396;
                        PRIM_PTR_INT__n_s_f_s += lastoffset*660;
                        PRIM_PTR_INT__o_s_d_s += lastoffset*468;
                        PRIM_PTR_INT__o_s_f_s += lastoffset*780;
                        PRIM_PTR_INT__q_s_d_s += lastoffset*546;
                        PRIM_PTR_INT__q_s_f_s += lastoffset*910;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////


            const double hAB[3] = { P.AB_x[ab], P.AB_y[ab], P.AB_z[ab] };


            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {
                const double hCD[3] = { Q.AB_x[cd+abcd], Q.AB_y[cd+abcd], Q.AB_z[cd+abcd] };

                // set up HRR pointers
                double const * restrict HRR_INT__i_s_d_s = INT__i_s_d_s + abcd * 168;
                double const * restrict HRR_INT__i_s_f_s = INT__i_s_f_s + abcd * 280;
                double const * restrict HRR_INT__k_s_d_s = INT__k_s_d_s + abcd * 216;
                double const * restrict HRR_INT__k_s_f_s = INT__k_s_f_s + abcd * 360;
                double const * restrict HRR_INT__l_s_d_s = INT__l_s_d_s + abcd * 270;
                double const * restrict HRR_INT__l_s_f_s = INT__l_s_f_s + abcd * 450;
                double const * restrict HRR_INT__m_s_d_s = INT__m_s_d_s + abcd * 330;
                double const * restrict HRR_INT__m_s_f_s = INT__m_s_f_s + abcd * 550;
                double const * restrict HRR_INT__n_s_d_s = INT__n_s_d_s + abcd * 396;
                double const * restrict HRR_INT__n_s_f_s = INT__n_s_f_s + abcd * 660;
                double const * restrict HRR_INT__o_s_d_s = INT__o_s_d_s + abcd * 468;
                double const * restrict HRR_INT__o_s_f_s = INT__o_s_f_s + abcd * 780;
                double const * restrict HRR_INT__q_s_d_s = INT__q_s_d_s + abcd * 546;
                double const * restrict HRR_INT__q_s_f_s = INT__q_s_f_s + abcd * 910;
                double * restrict HRR_INT__i_i_d_p = INT__i_i_d_p + real_abcd * 14112;

                // form INT__i_p_d_s
                ostei_general_hrr_J(6, 1, 2, 0, hAB, HRR_INT__k_s_d_s, HRR_INT__i_s_d_s, HRR_INT__i_p_d_s);

                // form INT__i_p_f_s
                ostei_general_hrr_J(6, 1, 3, 0, hAB, HRR_INT__k_s_f_s, HRR_INT__i_s_f_s, HRR_INT__i_p_f_s);

                // form INT__k_p_d_s
                ostei_general_hrr_J(7, 1, 2, 0, hAB, HRR_INT__l_s_d_s, HRR_INT__k_s_d_s, HRR_INT__k_p_d_s);

                // form INT__k_p_f_s
                ostei_general_hrr_J(7, 1, 3, 0, hAB, HRR_INT__l_s_f_s, HRR_INT__k_s_f_s, HRR_INT__k_p_f_s);

                // form INT__l_p_d_s
                ostei_general_hrr_J(8, 1, 2, 0, hAB, HRR_INT__m_s_d_s, HRR_INT__l_s_d_s, HRR_INT__l_p_d_s);

                // form INT__l_p_f_s
                ostei_general_hrr_J(8, 1, 3, 0, hAB, HRR_INT__m_s_f_s, HRR_INT__l_s_f_s, HRR_INT__l_p_f_s);

                // form INT__m_p_d_s
                ostei_general_hrr_J(9, 1, 2, 0, hAB, HRR_INT__n_s_d_s, HRR_INT__m_s_d_s, HRR_INT__m_p_d_s);

                // form INT__m_p_f_s
                ostei_general_hrr_J(9, 1, 3, 0, hAB, HRR_INT__n_s_f_s, HRR_INT__m_s_f_s, HRR_INT__m_p_f_s);

                // form INT__n_p_d_s
                ostei_general_hrr_J(10, 1, 2, 0, hAB, HRR_INT__o_s_d_s, HRR_INT__n_s_d_s, HRR_INT__n_p_d_s);

                // form INT__n_p_f_s
                ostei_general_hrr_J(10, 1, 3, 0, hAB, HRR_INT__o_s_f_s, HRR_INT__n_s_f_s, HRR_INT__n_p_f_s);

                // form INT__o_p_d_s
                ostei_general_hrr_J(11, 1, 2, 0, hAB, HRR_INT__q_s_d_s, HRR_INT__o_s_d_s, HRR_INT__o_p_d_s);

                // form INT__o_p_f_s
                ostei_general_hrr_J(11, 1, 3, 0, hAB, HRR_INT__q_s_f_s, HRR_INT__o_s_f_s, HRR_INT__o_p_f_s);

                // form INT__i_d_d_s
                ostei_general_hrr_J(6, 2, 2, 0, hAB, HRR_INT__k_p_d_s, HRR_INT__i_p_d_s, HRR_INT__i_d_d_s);

                // form INT__i_d_f_s
                ostei_general_hrr_J(6, 2, 3, 0, hAB, HRR_INT__k_p_f_s, HRR_INT__i_p_f_s, HRR_INT__i_d_f_s);

                // form INT__k_d_d_s
                ostei_general_hrr_J(7, 2, 2, 0, hAB, HRR_INT__l_p_d_s, HRR_INT__k_p_d_s, HRR_INT__k_d_d_s);

                // form INT__k_d_f_s
                ostei_general_hrr_J(7, 2, 3, 0, hAB, HRR_INT__l_p_f_s, HRR_INT__k_p_f_s, HRR_INT__k_d_f_s);

                // form INT__l_d_d_s
                ostei_general_hrr_J(8, 2, 2, 0, hAB, HRR_INT__m_p_d_s, HRR_INT__l_p_d_s, HRR_INT__l_d_d_s);

                // form INT__l_d_f_s
                ostei_general_hrr_J(8, 2, 3, 0, hAB, HRR_INT__m_p_f_s, HRR_INT__l_p_f_s, HRR_INT__l_d_f_s);

                // form INT__m_d_d_s
                ostei_general_hrr_J(9, 2, 2, 0, hAB, HRR_INT__n_p_d_s, HRR_INT__m_p_d_s, HRR_INT__m_d_d_s);

                // form INT__m_d_f_s
                ostei_general_hrr_J(9, 2, 3, 0, hAB, HRR_INT__n_p_f_s, HRR_INT__m_p_f_s, HRR_INT__m_d_f_s);

                // form INT__n_d_d_s
                ostei_general_hrr_J(10, 2, 2, 0, hAB, HRR_INT__o_p_d_s, HRR_INT__n_p_d_s, HRR_INT__n_d_d_s);

                // form INT__n_d_f_s
                ostei_general_hrr_J(10, 2, 3, 0, hAB, HRR_INT__o_p_f_s, HRR_INT__n_p_f_s, HRR_INT__n_d_f_s);

                // form INT__i_f_d_s
                ostei_general_hrr_J(6, 3, 2, 0, hAB, HRR_INT__k_d_d_s, HRR_INT__i_d_d_s, HRR_INT__i_f_d_s);

                // form INT__i_f_f_s
                ostei_general_hrr_J(6, 3, 3, 0, hAB, HRR_INT__k_d_f_s, HRR_INT__i_d_f_s, HRR_INT__i_f_f_s);

                // form INT__k_f_d_s
                ostei_general_hrr_J(7, 3, 2, 0, hAB, HRR_INT__l_d_d_s, HRR_INT__k_d_d_s, HRR_INT__k_f_d_s);

                // form INT__k_f_f_s
                ostei_general_hrr_J(7, 3, 3, 0, hAB, HRR_INT__l_d_f_s, HRR_INT__k_d_f_s, HRR_INT__k_f_f_s);

                // form INT__l_f_d_s
                ostei_general_hrr_J(8, 3, 2, 0, hAB, HRR_INT__m_d_d_s, HRR_INT__l_d_d_s, HRR_INT__l_f_d_s);

                // form INT__l_f_f_s
                ostei_general_hrr_J(8, 3, 3, 0, hAB, HRR_INT__m_d_f_s, HRR_INT__l_d_f_s, HRR_INT__l_f_f_s);

                // form INT__m_f_d_s
                ostei_general_hrr_J(9, 3, 2, 0, hAB, HRR_INT__n_d_d_s, HRR_INT__m_d_d_s, HRR_INT__m_f_d_s);

                // form INT__m_f_f_s
                ostei_general_hrr_J(9, 3, 3, 0, hAB, HRR_INT__n_d_f_s, HRR_INT__m_d_f_s, HRR_INT__m_f_f_s);

                // form INT__i_g_d_s
                ostei_general_hrr_J(6, 4, 2, 0, hAB, HRR_INT__k_f_d_s, HRR_INT__i_f_d_s, HRR_INT__i_g_d_s);

                // form INT__i_g_f_s
                ostei_general_hrr_J(6, 4, 3, 0, hAB, HRR_INT__k_f_f_s, HRR_INT__i_f_f_s, HRR_INT__i_g_f_s);

                // form INT__k_g_d_s
                ostei_general_hrr_J(7, 4, 2, 0, hAB, HRR_INT__l_f_d_s, HRR_INT__k_f_d_s, HRR_INT__k_g_d_s);

                // form INT__k_g_f_s
                ostei_general_hrr_J(7, 4, 3, 0, hAB, HRR_INT__l_f_f_s, HRR_INT__k_f_f_s, HRR_INT__k_g_f_s);

                // form INT__l_g_d_s
                ostei_general_hrr_J(8, 4, 2, 0, hAB, HRR_INT__m_f_d_s, HRR_INT__l_f_d_s, HRR_INT__l_g_d_s);

                // form INT__l_g_f_s
                ostei_general_hrr_J(8, 4, 3, 0, hAB, HRR_INT__m_f_f_s, HRR_INT__l_f_f_s, HRR_INT__l_g_f_s);

                // form INT__i_h_d_s
                ostei_general_hrr_J(6, 5, 2, 0, hAB, HRR_INT__k_g_d_s, HRR_INT__i_g_d_s, HRR_INT__i_h_d_s);

                // form INT__i_h_f_s
                ostei_general_hrr_J(6, 5, 3, 0, hAB, HRR_INT__k_g_f_s, HRR_INT__i_g_f_s, HRR_INT__i_h_f_s);

                // form INT__k_h_d_s
                ostei_general_hrr_J(7, 5, 2, 0, hAB, HRR_INT__l_g_d_s, HRR_INT__k_g_d_s, HRR_INT__k_h_d_s);

                // form INT__k_h_f_s
                ostei_general_hrr_J(7, 5, 3, 0, hAB, HRR_INT__l_g_f_s, HRR_INT__k_g_f_s, HRR_INT__k_h_f_s);

                // form INT__i_i_d_s
                ostei_general_hrr_J(6, 6, 2, 0, hAB, HRR_INT__k_h_d_s, HRR_INT__i_h_d_s, HRR_INT__i_i_d_s);

                // form INT__i_i_f_s
                ostei_general_hrr_J(6, 6, 3, 0, hAB, HRR_INT__k_h_f_s, HRR_INT__i_h_f_s, HRR_INT__i_i_f_s);

                // form INT__i_i_d_p
                for(ibra = 0; ibra < 784; ++ibra)
                {
                    HRR_INT__i_i_d_p[ibra * 18 + 0] = HRR_INT__i_i_f_s[ibra * 10 + 0] + ( hCD[0] * HRR_INT__i_i_d_s[ibra * 6 + 0] );

                    HRR_INT__i_i_d_p[ibra * 18 + 1] = HRR_INT__i_i_f_s[ibra * 10 + 1] + ( hCD[1] * HRR_INT__i_i_d_s[ibra * 6 + 0] );

                    HRR_INT__i_i_d_p[ibra * 18 + 2] = HRR_INT__i_i_f_s[ibra * 10 + 2] + ( hCD[2] * HRR_INT__i_i_d_s[ibra * 6 + 0] );

                    HRR_INT__i_i_d_p[ibra * 18 + 3] = HRR_INT__i_i_f_s[ibra * 10 + 1] + ( hCD[0] * HRR_INT__i_i_d_s[ibra * 6 + 1] );

                    HRR_INT__i_i_d_p[ibra * 18 + 4] = HRR_INT__i_i_f_s[ibra * 10 + 3] + ( hCD[1] * HRR_INT__i_i_d_s[ibra * 6 + 1] );

                    HRR_INT__i_i_d_p[ibra * 18 + 5] = HRR_INT__i_i_f_s[ibra * 10 + 4] + ( hCD[2] * HRR_INT__i_i_d_s[ibra * 6 + 1] );

                    HRR_INT__i_i_d_p[ibra * 18 + 6] = HRR_INT__i_i_f_s[ibra * 10 + 2] + ( hCD[0] * HRR_INT__i_i_d_s[ibra * 6 + 2] );

                    HRR_INT__i_i_d_p[ibra * 18 + 7] = HRR_INT__i_i_f_s[ibra * 10 + 4] + ( hCD[1] * HRR_INT__i_i_d_s[ibra * 6 + 2] );

                    HRR_INT__i_i_d_p[ibra * 18 + 8] = HRR_INT__i_i_f_s[ibra * 10 + 5] + ( hCD[2] * HRR_INT__i_i_d_s[ibra * 6 + 2] );

                    HRR_INT__i_i_d_p[ibra * 18 + 9] = HRR_INT__i_i_f_s[ibra * 10 + 3] + ( hCD[0] * HRR_INT__i_i_d_s[ibra * 6 + 3] );

                    HRR_INT__i_i_d_p[ibra * 18 + 10] = HRR_INT__i_i_f_s[ibra * 10 + 6] + ( hCD[1] * HRR_INT__i_i_d_s[ibra * 6 + 3] );

                    HRR_INT__i_i_d_p[ibra * 18 + 11] = HRR_INT__i_i_f_s[ibra * 10 + 7] + ( hCD[2] * HRR_INT__i_i_d_s[ibra * 6 + 3] );

                    HRR_INT__i_i_d_p[ibra * 18 + 12] = HRR_INT__i_i_f_s[ibra * 10 + 4] + ( hCD[0] * HRR_INT__i_i_d_s[ibra * 6 + 4] );

                    HRR_INT__i_i_d_p[ibra * 18 + 13] = HRR_INT__i_i_f_s[ibra * 10 + 7] + ( hCD[1] * HRR_INT__i_i_d_s[ibra * 6 + 4] );

                    HRR_INT__i_i_d_p[ibra * 18 + 14] = HRR_INT__i_i_f_s[ibra * 10 + 8] + ( hCD[2] * HRR_INT__i_i_d_s[ibra * 6 + 4] );

                    HRR_INT__i_i_d_p[ibra * 18 + 15] = HRR_INT__i_i_f_s[ibra * 10 + 5] + ( hCD[0] * HRR_INT__i_i_d_s[ibra * 6 + 5] );

                    HRR_INT__i_i_d_p[ibra * 18 + 16] = HRR_INT__i_i_f_s[ibra * 10 + 8] + ( hCD[1] * HRR_INT__i_i_d_s[ibra * 6 + 5] );

                    HRR_INT__i_i_d_p[ibra * 18 + 17] = HRR_INT__i_i_f_s[ibra * 10 + 9] + ( hCD[2] * HRR_INT__i_i_d_s[ibra * 6 + 5] );

                }


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

int ostei_i_i_p_d(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__i_i_p_d)
{
    double Q_AB[3*Q.nshell12];
    struct simint_multi_shellpair Q_tmp = Q;
    Q_tmp.PA_x = Q.PB_x;  Q_tmp.PA_y = Q.PB_y;  Q_tmp.PA_z = Q.PB_z;
    Q_tmp.PB_x = Q.PA_x;  Q_tmp.PB_y = Q.PA_y;  Q_tmp.PB_z = Q.PA_z;
    Q_tmp.AB_x = Q_AB;
    Q_tmp.AB_y = Q_AB + Q.nshell12;
    Q_tmp.AB_z = Q_AB + 2*Q.nshell12;

    for(int i = 0; i < Q.nshell12; i++)
    {
        Q_tmp.AB_x[i] = -Q.AB_x[i];
        Q_tmp.AB_y[i] = -Q.AB_y[i];
        Q_tmp.AB_z[i] = -Q.AB_z[i];
    }

    int ret = ostei_i_i_d_p(P, Q_tmp, screen_tol, work, INT__i_i_p_d);
    double buffer[14112] SIMINT_ALIGN_ARRAY_DBL;

    for(int q = 0; q < ret; q++)
    {
        int idx = 0;
        for(int a = 0; a < 28; ++a)
        for(int b = 0; b < 28; ++b)
        for(int c = 0; c < 3; ++c)
        for(int d = 0; d < 6; ++d)
            buffer[idx++] = INT__i_i_p_d[q*14112+a*504+b*18+d*3+c];

        memcpy(INT__i_i_p_d+q*14112, buffer, 14112*sizeof(double));
    }

    return ret;
}

